{{ XOR Fractal - VGA - PASM }}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ

  pix: "VGA64.spin"

PUB demo

  pix.PIXEngineStart(2)                     'start VGA driver
  waitcnt(clkfreq/100 + cnt)                'wait 10ms
  cognew(@xor_asm, pix.displayPointer)    'start PASM cog

DAT
xor_asm       mov  screen,par

              mov  t,#0
loopt         mov  y,#0
loopy         mov  x,#0
              
loopx         mov  val,x
              xor  val,y
              add  val,t

              mov  t1,val
              mov  t2,#10
              
              shl  t2,#15
              mov  tmp,#16
loopd         cmpsub t1,t2 wc
              rcl  t1,#1
              djnz tmp,#loopd
              shr  t1,#16

              mov  val,t1
                        
              call #plot
              add  x,#1
              cmp  x,width  wc
        if_b  jmp  #loopx
              add  y,#1
              cmp  y,height  wc
        if_b  jmp  #loopy
              add  t,#1
              jmp  #loopt

plot          mov  tmp,y                   'calc  screen address
              shl  y,#5
              shl  tmp,#7
              add  tmp,y                   'my*32 + my*128 =^= mx*160
              shr  y,#5                    'restore my
              add  tmp,x                   '+mx
              add  tmp,screen               '+screen base addr
              shl  val,#2
              or   val,#3                  'color
              wrbyte val,tmp               'write into screen
plot_ret      ret

tmp           long 0
t             long 0
x             long 0
y             long 0
val           long 0
t1            long 0
t2            long 0
width         long 160
height        long 120
screen        long 0